
;(setq SS (getvar "SCREENSIZE") ; screen size in pixels
;VS (getvar "VIEWSIZE") ; screen height in drawing units
;PB (getvar "pickbox") ; get current pickbox size
;SWP (car SS) ; width of screen in pixels
;SHP (cadr SS) ; height of screen in pixels
;AR (/ SWP SHP) ; aspect ratio width/height
;WSD (* VS AR) ; width of screen dwg units = ratio times
;height
;PPDU (/ WSD SWP) ; pixels per drawing unit
;BOX (/ (* VS (* 2 PB)) SHP) ; drawing units per pixel
;)


;(setq p (mapcar (function (lambda (x / y) (setq y (cdr x)) (if (/= (car x) 10) x (append (list 10) (polar p0 (angle p0 y) (* 2 (distance p0 y))))))) p))

(defun c:LL () (load "phatch")(alert "Loaded."))



;;; ------------- REGIONTOPOLY --------------------------
	(defun fx:REGIONTOPOLY (eregion / lastent tempss)
		 ; given a region ename,
		 ; explode him and pedit join to a poly
		(setq lastent (entlast)
			tempss (ssadd)
		) ; setq
		(command "_.EXPLODE" eregion)
		(while (setq lastent (entnext lastent))
			(ssadd lastent tempss)
		) ; while
		(command "_.PEDIT" "_M" tempss "" "_Y" "_J" "0" "") ; multiple, Yes convert, Join
		(setq tempss nil)

		(entlast) ; our poly! (i hope)
	) ; REGIONTOPOLY
;;; -----------------------------------------------------


(defun c:PHATCH (/ *error* oldlay esel hatchent polyent brushent exitflag p2 t1 t2 px DELETEENTITIES)
				 ; esel - entity selection
				 ; hatchent - (entity of source hatch)
				 ; polyent - (entity of boundary)
				 ; brushent - (entity of brush boundary)

	 ; prep for being called from Place Hatch

	(setq *error* AXIS_ERR)

	(setvar "DELOBJ" 1) ; we are assuming source objects are erased

	(setq oldlay (getvar "CLAYER"))

	 ; select hatch (or passed -- as hatch info)
	(if (and (setq esel (entsel #FX0143)) ; "\nSelect hatch: "
			(setq hatchent (entget (car esel)))
		) ; and
		(if (= (cdr (assoc 0 hatchent)) "HATCH")
			(setq hatchpat (cdr (assoc 2 hatchent)))
			 ; otherwise bounce
			(progn
				(fx:ALERT #FX0144) ; "Not a hatch."
				(exit)
			) ; progn	
		) ; if
		 ; otherwise bounce
		(exit)
	) ; if

	 ; locate boundary (or need to make on first click)
	(if (setq polyent (fx:HATCHOWNER hatchent))
		 ; turn on boundary layer (or pull from preferences)
		(fx:GOLAYER (list (cdr (assoc 8 polyent))))
		 ; otherwise, bounce
		(progn
			(fx:ALERT #FX0129) ; "Can not locate bounding polyline."
			(exit)
		) ; progn
	) ; if



	 ; calc size of brush
	 
	 ; hatch brush
	(if (fx:MAKE_CIRCLE (trans (cadr esel) 1 0) 10)
		(setq brushent (entget (entlast))
			DELETEENTITIES (cons (entlast) DELETEENTITIES)
		) ; setq
		 ; otherwise bounce
		(exit)
	) ; if
	 
	 ; set up brush to go away on esc

	 ; loop on mouse movement
	 	 ; right click / enter = exit
	 	 ; left click = do magic (extend existing, or place initially)
	 	 ; q/e = change brush
	 	 ; w/s = bigger/smaller
	 	 ; a/d = rotate left/right

	(while (and (not exitflag)
				(setq p2 (grread t 12 0)) ; t = track, 12 = no esc, cursor, 0 = cursor
			) ; and

;---------
;(print p2)
;---------
	
		(cond
			(	(= (car p2) 5) ; tracking
				 ; update brush
				(setq p2 (cadr p2) ; just the point
					p2 (trans p2 1 0)
					brushent (subst (append (list 10) p2) (assoc 10 brushent) brushent)
					brushent (entmod brushent)
				) ; setq
			) ; tracking
			
			(	(= (car p2) 3) ; left click
				 ; make a copy of polyent object
				(if (entmake (cdr polyent))
					(progn
						(command "_.REGION" (entlast) "")
						(setq t1 (entlast))
					) ; progn
					 ; otherwise, not good
					(exit)
				) ; if
				 ; make a copy of brushent object
				(if (entmake (cdr brushent))
					(progn
						(command "_.REGION" (entlast) "")
						(setq t2 (entlast))
					) ; progn
					 ; otherwise, not good
					(exit)
				) ; if
				 ; union them
				(command "_.UNION" t1 t2 "")
				 ; region to poly
				(setq px (fx:REGIONTOPOLY (entlast))
					px (entget px)
				) ; setq
				 ; delete that object
				(entdel (cdr (assoc -1 px)))
				 ; take that plist definition
				(setq px (member (assoc 90 px) px)
					 ; add plist to polyent, update
					polyent (reverse (cdr (member (assoc 90 polyent) (reverse polyent))))
					polyent (append polyent px)
					polyent (entmod polyent)
				) ; setq
				(command "_.REGEN")
			) ; left click
			
			(	(= (car p2) 2) ; keyboard
				(cond
					(	(member (cadr p2) (list (ascii "W") (ascii "w") (ascii "S") (ascii "s"))) ; W/S - bigger/smaller
						(setq t1 (cdr (assoc 40 brushent)) ; current radius
							t1 (if (member (cadr p2) (list (ascii "W") (ascii "w"))) ; bigger
									(* t1 1.1)
									 ; otherwise, smaller
									(* t1 0.9)
								) ; if
							brushent (subst (cons 40 t1) (assoc 40 brushent) brushent)
							brushent (entmod brushent)
						) ; setq
					) ; W/S
				) ; cond
			) ; keyboard

			(	 t ; right click, click in ribbon, etc
				(if brushent (entdel (cdr (assoc -1 brushent))))
				(setq DELETEENTITIES nil
					exitflag t
				) ; setq
			) ; otherwise
		) ; cond

	) ; while cursor move


	(fx:GOLAYER (list oldlay))

(princ)
) ; PHATCH



; command region
	 ; delobj - 0 delete original, 1 - keep original



;; brush
;(setq p2 (member (assoc 90 p2) p2))
;
;; original
;(setq p1 (reverse (cdr (member (assoc 90 p1) (reverse p1)))))
;
;(setq p1 (append p1 p2))
;(entmod p1)

(princ)