

(defun c:LL () (load "phatch") (c:PHATCH))


;;; ------------------- GOLAYER -------------------------
	 ; name lineweith color linetype nonplot transparency
	(defun fx:GOLAYER (laylist / layername layerwt layercolor layerlt nonplot transparency layerx CHANGEFLAG otype elist)
		 ; name lineweight color linetype nonplot
		(setq layername (nth 0 laylist) 
			layerwt (nth 1 laylist) 
			layercolor (nth 2 laylist) 
			layerlt (nth 3 laylist)
			layerlt (fx:LTNAME layerlt)
			nonplot (if _SMARTNPLT ; then we figure it out from layer name
						(if (vl-string-search #FX1148 layername) 0 1) ; if nplt
						 ; otherwise, use the value passed to us
						(if (nth 4 laylist) 0 1)
					) ; if
			transparency (nth 5 laylist)
		) ; setq
		(if (not layercolor) 
			(setq layercolor 7)
		) ; if
		(if (not layerwt) (setq layerwt -3) (setq layerwt (fix (* layerwt 100))))
		(if (not layerlt) (setq layerlt "Continuous"))
		 ; okay, setup done, let's see if we can switch to this layer, make it as necessary
		(if (if (not (tblsearch "LAYER" layername))
				(progn 
					 ; can't make it unless the linetype exists
					(if (not (fx:LOADLINETYPE layerlt nil))
						 ; fine, keep it continuous then
						(setq layerlt "Continuous")
					) ; if

					(setq elist (list 
						(cons 0 "LAYER") 
						(cons 100 "AcDbSymbolTableRecord") 
						(cons 100 "AcDbLayerTableRecord") 
						(cons 2 layername) 
						(cons 6 layerlt)
						(cons 62 (if (> layercolor 255) 0 layercolor))
						(cons 70 0) 
						(cons 290 nonplot)
						(cons 370 layerwt)
					)) ; list setq
					(if (> layercolor 255) ; truecolor
						(setq elist (append elist (list (cons 420 layercolor))))
					) ; if

					(if (not (entmake elist))
						(fx:alert (strcat #FX0052 " " layername "."))
						 ; otherwise, cool to switch to
						(progn
							 ; if transparency, we need to set that via command line
							(if transparency 
								(command "_.-LAYER" "_TR" transparency layername "")
							) ; if
							 t
						) ; progn
					) ; if
				) ; progn
				 ; it exists, but we need to make sure it's unlocked, unfrozen, and turned on
				(progn 
					(setq layerx (entget (tblobjname "LAYER" layername)))
					(if (cdr (assoc 62 layerx)) ; if color assigned
						(if (minusp (cdr (assoc 62 layerx))) ; if layer is turned off
							(setq layerx (subst (cons 62 (abs (cdr (assoc 62 layerx)))) (assoc 62 layerx) layerx) 
								CHANGEFLAG t
							) ; setq
						) ; if layer off
					) ; if layer has color data
					(if (> (cdr (assoc 70 layerx)) 0) ; layer is frozen and/or locked
						(setq layerx (subst (cons 70 0) (assoc 70 layerx) layerx) 
							CHANGEFLAG t
						) ; setq
					) ; if
					(if CHANGEFLAG 
						(if (not (entmod layerx)) 
							(fx:alert #FX0053)
							 ; otherwise, go ahead
							 t
						) ; if
						 ; otherwise, it's on, thawed, unlocked
						 t
					) ; if layer locked/frozen/off
				) ; progn
			) ; if layer exists
			(setvar "CLAYER" layername)
		) ; if able to switch to layer
	) ; GOLAYER
;;; -----------------------------------------------------

;;; ------------------ fx:MAKE_CIRCLE -------------------
	(defun fx:MAKE_CIRCLE (px dx / entity1)
		(setq entity1 (list (cons 0 "CIRCLE") 
									(cons 100 "AcDbEntity")
									(cons 100 "AcDbCircle") 
									(append (list 10) px) 
									(cons 40 (/ dx 2.0)) ; radius
									(cons 67 0) ; create in MS
						) ; list
			entity1 (entmake entity1)
		) ; setq
	) ; fx:MAKE_CIRCLE
;;; -----------------------------------------------------

;;; ------------- REGIONTOPOLY --------------------------
	(defun fx:REGIONTOPOLY (eregion / lastent tempss)
		 ; given a region ename,
		 ; explode him and pedit join to a poly
		(setq lastent (entlast)
			tempss (ssadd)
		) ; setq
		(command "_.EXPLODE" eregion)
		(while (setq lastent (entnext lastent))
			(ssadd lastent tempss)
		) ; while
		(command "_.PEDIT" "_M" tempss "" "_Y" "_J" "0" "") ; multiple, Yes convert, Join
		(setq tempss nil)

		(entlast) ; our poly! (i hope)
	) ; REGIONTOPOLY
;;; -----------------------------------------------------





(defun c:PHATCH (/ *error* oldlay p2 exitflag esel i r t1 t2 HATCHENT BOUNDENT DELETEENTITIES)
				 ; esel - 
				 ; HATCHENT - 
				 ; BOUNDENT - 
	(setq *error* AXIS_ERR)

	 ; come in from Place Hatch (prepare to just make one)


	(setq oldlay (getvar "CLAYER"))
	(setvar "DELOBJ" 0) ; i need my source objects when converting to region

	 ; select my hatch
	(if (and (setq esel (entsel #FX0143)) ; "\nSelect hatch: "
			(setq HATCHENT (entget (car esel)))
			(= (cdr (assoc 0 HATCHENT)) "HATCH")
		) ; and
		 ; get the boundary
		(if (setq BOUNDENT (fx:HATCHOWNER HATCHENT))
			 ; layer
			(fx:GOLAYER (list (cdr (assoc 8 BOUNDENT))))

			 ; otherwise, no boundary
			(progn
				(fx:ALERT #FX0129) "Can not locate bounding polyline."
				(exit)
			) ; progn
		) ; if

		 ; otherwise,
		(progn
			(fx:ALERT #FX0144) "Not a hatch."
			(exit)
		) ; progn
	) ; if


	 ; make my brush
	 ; -------------- view size logic -------------------------
	(if (fx:MAKE_CIRCLE (trans (cadr esel) 1 0) 10.0)
		(setq BRUSHENT (entget (entlast))
			DELETEENTITIES (list (entlast))
		) ; setq
		
		 ; otherwise, exit
		(exit)
	) ; if

	(setq exitflag nil)
	(while (and (not exitflag)
				(setq p2 (grread t 12 1)) ; t = Track, 12 cursor setting, no console break. 1 = just the crosshairs
			) ; and

;------------
;(print p2)
;------------

		(cond
			(	(= (car p2) 5) ; tracking
				 ; move my brush
				(setq p2 (cadr p2) ; just the point
					p2 (trans p2 1 0) ; into WCS
					BRUSHENT (subst (append (list 10) p2) (assoc 10 BRUSHENT) BRUSHENT)
					BRUSHENT (entmod BRUSHENT)
				) ; setq
			) ; tracking
			
			(	(= (car p2) 3) ; left click
				 ; do our magic!

				 ; region
				(command "_.REGION" (cdr (assoc -1 BOUNDENT)) "")
				(setq t1 (entlast))
					 ; what if that failed??? ---------
				(command "_.REGION" (cdr (assoc -1 BRUSHENT)) "")
				(setq t2 (entlast))
				 ; union
				(command "_.UNION" t1 t2 "")
				(setq t1 (entlast)) ; our union object
				(setq t2 (entget (fx:REGIONTOPOLY t1))) ; my new boundary
				(entdel (cdr (assoc -1 t2)))
				
				 ; add new boundary to the existing and entmod
				(setq BOUNDENT (reverse (cdr (member (assoc 90 BOUNDENT) (reverse BOUNDENT)))))
				(setq t2 (member (assoc 90 t2) t2)) ; just the new boundary
				(setq BOUNDENT (append BOUNDENT t2)
					BOUNDENT (entmod BOUNDENT)
				) ; setq
				(command "_.REGEN")

			) ; left click
			
			(	(= (car p2) 2) ; keyboard
				(setq p2 (cadr p2)) ; to the keycode
				(cond
					 ; A/D rotate
				 
					 ; W/S bigger, smaller
					(	(member p2 (list (ascii "W") (ascii "w") (ascii "S") (ascii "s")))
						 ; BRUSHENT, make bigger/smaller
						(setq r (cdr (assoc 40 BRUSHENT)) ; existing radius
							r (if (member p2 (list (ascii "W") (ascii "w"))) ; BIGGER
									(* r 1.1)
									 ; otherwise, smaller
									(* r 0.9)
								) ; if
							BRUSHENT (subst (cons 40 r) (assoc 40 BRUSHENT) BRUSHENT)
							BRUSHENT (entmod BRUSHENT)
						) ; setq
					) ; W/S

					 ; spacebar, enter!!!! exit! ----------------

				) ; cond
			) ; keyboard

			(	 t ; right click, click in ribbon, etc
				(foreach i DELETEENTITIES (entdel i))
				(setq exitflag t)
			) ; otherwise
		) ; cond

	) ; while cursor move


	(fx:GOLAYER (list oldlay))

(princ)
) ; PHATCH


(princ)



