

(defun c:LL () (load "phatch") (c:PHATCH))


;;; ------------------- GOLAYER -------------------------
	 ; name lineweith color linetype nonplot transparency
	(defun fx:GOLAYER (laylist / layername layerwt layercolor layerlt nonplot transparency layerx CHANGEFLAG otype elist)
		 ; name lineweight color linetype nonplot
		(setq layername (nth 0 laylist) 
			layerwt (nth 1 laylist) 
			layercolor (nth 2 laylist) 
			layerlt (nth 3 laylist)
			layerlt (fx:LTNAME layerlt)
			nonplot (if _SMARTNPLT ; then we figure it out from layer name
						(if (vl-string-search #FX1148 layername) 0 1) ; if nplt
						 ; otherwise, use the value passed to us
						(if (nth 4 laylist) 0 1)
					) ; if
			transparency (nth 5 laylist)
		) ; setq
		(if (not layercolor) 
			(setq layercolor 7)
		) ; if
		(if (not layerwt) (setq layerwt -3) (setq layerwt (fix (* layerwt 100))))
		(if (not layerlt) (setq layerlt "Continuous"))
		 ; okay, setup done, let's see if we can switch to this layer, make it as necessary
		(if (if (not (tblsearch "LAYER" layername))
				(progn 
					 ; can't make it unless the linetype exists
					(if (not (fx:LOADLINETYPE layerlt nil))
						 ; fine, keep it continuous then
						(setq layerlt "Continuous")
					) ; if

					(setq elist (list 
						(cons 0 "LAYER") 
						(cons 100 "AcDbSymbolTableRecord") 
						(cons 100 "AcDbLayerTableRecord") 
						(cons 2 layername) 
						(cons 6 layerlt)
						(cons 62 (if (> layercolor 255) 0 layercolor))
						(cons 70 0) 
						(cons 290 nonplot)
						(cons 370 layerwt)
					)) ; list setq
					(if (> layercolor 255) ; truecolor
						(setq elist (append elist (list (cons 420 layercolor))))
					) ; if

					(if (not (entmake elist))
						(fx:alert (strcat #FX0052 " " layername "."))
						 ; otherwise, cool to switch to
						(progn
							 ; if transparency, we need to set that via command line
							(if transparency 
								(command "_.-LAYER" "_TR" transparency layername "")
							) ; if
							 t
						) ; progn
					) ; if
				) ; progn
				 ; it exists, but we need to make sure it's unlocked, unfrozen, and turned on
				(progn 
					(setq layerx (entget (tblobjname "LAYER" layername)))
					(if (cdr (assoc 62 layerx)) ; if color assigned
						(if (minusp (cdr (assoc 62 layerx))) ; if layer is turned off
							(setq layerx (subst (cons 62 (abs (cdr (assoc 62 layerx)))) (assoc 62 layerx) layerx) 
								CHANGEFLAG t
							) ; setq
						) ; if layer off
					) ; if layer has color data
					(if (> (cdr (assoc 70 layerx)) 0) ; layer is frozen and/or locked
						(setq layerx (subst (cons 70 0) (assoc 70 layerx) layerx) 
							CHANGEFLAG t
						) ; setq
					) ; if
					(if CHANGEFLAG 
						(if (not (entmod layerx)) 
							(fx:alert #FX0053)
							 ; otherwise, go ahead
							 t
						) ; if
						 ; otherwise, it's on, thawed, unlocked
						 t
					) ; if layer locked/frozen/off
				) ; progn
			) ; if layer exists
			(setvar "CLAYER" layername)
		) ; if able to switch to layer
	) ; GOLAYER
;;; -----------------------------------------------------

;;; ------------------ fx:MAKE_CIRCLE -------------------
	(defun fx:MAKE_CIRCLE (px dx / entity1)
		(setq entity1 (list (cons 0 "CIRCLE") 
									(cons 100 "AcDbEntity")
									(cons 100 "AcDbCircle") 
									(append (list 10) px) 
									(cons 40 (/ dx 2.0)) ; radius
									(cons 67 0) ; create in MS
						) ; list
			entity1 (entmake entity1)
		) ; setq
	) ; fx:MAKE_CIRCLE
;;; -----------------------------------------------------

;;; ------------- REGIONTOPOLY --------------------------
	(defun fx:REGIONTOPOLY (eregion / lastent tempss)
		 ; given a region ename,
		 ; explode him and pedit join to a poly
		(setq lastent (entlast)
			tempss (ssadd)
		) ; setq
		(command "_.EXPLODE" eregion)
		(while (setq lastent (entnext lastent))
			(ssadd lastent tempss)
		) ; while
		(command "_.PEDIT" "_M" tempss "" "_Y" "_J" "0" "") ; multiple, Yes convert, Join
		(setq tempss nil)

		(entlast) ; our poly! (i hope)
	) ; REGIONTOPOLY
;;; -----------------------------------------------------



(defun c:PHATCH (/ *error* oldlay p2 exitflag esel i r t1 t2 HATCHENT BOUNDENT DELETEENTITIES)
					 ; esel - 
					 ; BOUNDENT -
					 ; HATCHENT - 
	(setq *error* AXIS_ERR)

	 ; --- consider, Place Hatch ---@@

	 ; sysvars
	(setq oldlay (getvar "CLAYER"))
	(setvar "DELOBJ" 0) ; we need the originals

	 ; select a hatch
	(if 
		(and ; it's a hatch
			 ; select hatch
			(setq esel (entsel #FX0143)) ; "\nSelect hatch: "
		 	 ; ---- consider, looping until they select a hatch @@
			(setq HATCHENT (entget (car esel)))
			 ; confirm it's hatch!
			(= (cdr (assoc 0 HATCHENT)) "HATCH")
		) ; and
		 ; continue to get boundary
		(if (setq BOUNDENT (fx:HATCHOWNER HATCHENT)) ; then turn on layer
			 ; turn on the boundary layer
			(fx:GOLAYER (list (cdr (assoc 8 BOUNDENT))))
			 ; otherwise, no boundary found
			(progn
				(fx:ALERT #FX0129) ; "Can not locate bounding polyline."
				(exit)
			) ; progn
		) ; if
		 ; otherwise, exit
		(progn
			(fx:ALERT #FX0144) ; "Not a hatch."
			(exit)
		) ; progn
	) ; if
	 ; here: i have BOUNDENT, and HATCHENT, layer is on and active


		 ; where to store brushes? default? snap to last used? ---------@@
	 	 ; determine initial size -----------------@@
	 ; make my brush
	(if (fx:MAKE_CIRCLE (trans (cadr esel) 1 0) 10.0)
		(setq BRUSHENT (entget (entlast))
			DELETEENTITIES (list (entlast))
		) ; setq
		 ; otherwise, oops
		(exit)
	) ; if


	(setq exitflag nil)
	(while 
			(and (not exitflag)
				(setq p2 (grread t 12 0)) ; t = track, 12 = console break, crosshair setting, 0 = crosshair
			) ; and

;------------
;(print p2)
;------------

		 ; process the input
		(cond
			(	(= (car p2) 5) ; tracking - update the brush position
				 ; update brush position
				 ; -------- helper fucntion to move all pts in poly
				(setq p2 (cadr p2) ; just the point
					p2 (trans p2 1 0) ; WCS
					BRUSHENT (subst (append (list 10) p2) (assoc 10 BRUSHENT) BRUSHENT)
					BRUSHENT (entmod BRUSHENT)
					 ; --- if not brushent @@
				) ; setq
			) ; tracking
			
			(	(= (car p2) 3) ; left click - do our magic
				 ; do my magic!

				 ; convert boundary and brush to regions
				(command "_.REGION" (cdr (assoc -1 BOUNDENT)) "")
				 ; if success? @@
				(setq t1 (entlast)) ; bound as a region

				(command "_.REGION" (cdr (assoc -1 BRUSHENT)) "")
				 ; if success? @@
				(setq t2 (entlast)) ; brush as a region

				 ; union them
				(command "_.UNION" t1 t2 "")
				 ; check success? @@ -- was it an actual union?
				(setq t1 (entlast)) ; our union'ed region

				 ; back to a polyline
				(if (fx:REGIONTOPOLY t1)
					 ; update boundary
					(progn
						(setq BOUNDENT (reverse (cdr (member (assoc 90 BOUNDENT) (reverse BOUNDENT)))))

						(setq t2 (entget (entlast)) ; the union'ed region, exploded, pedit'ed and joined, now a poly
							 ; our new boundary
							t2 (member (assoc 90 t2) t2)
						) ; setq
						(entdel (entlast))

						(setq BOUNDENT (append BOUNDENT t2)
							BOUNDENT (entmod BOUNDENT)
						) ; setq
						
						(command "_.REGEN") ; ----- better way? @@
					) ; progn

					 ; on failure, @@

				) ; if
			) ; left click
			
			(	(= (car p2) 2) ; keyboard - bigger/smaller
				(setq p2 (cadr p2)) ; just the ascii code
				(cond
					 ; W/S - Bigger/Smaller
					(	(member p2 (list (ascii "W") (ascii "w") (ascii "S") (ascii "s"))) ; ------ @@
						 ; make brush bigger/smaller
						 ; if poly, move all points in or out ---@@
						(setq r (cdr (assoc 40 BRUSHENT))
							r (if (member p2 (list (ascii "W") (ascii "w")))
									(* r 1.1)
									 ; otherwise, smaller
									(* r 0.9)
								) ; if
							BRUSHENT (subst (cons 40 r) (assoc 40 BRUSHENT) BRUSHENT)
							BRUSHENT (entmod BRUSHENT)
							 ; --- if fail @@
						) ; setq
					) ; w/s

					 ; A/D - Rotate @@ 
					 
					 ; U - step backwards
				) ; cond
			) ; keyboard

			(	 t ; right click, click in ribbon, etc
				 ; exit
				(foreach i DELETEENTITIES (entdel i))
				(setq exitflag t)
			) ; otherwise
		) ; cond

	) ; while cursor move


	(fx:GOLAYER (list oldlay))


(princ)
) ; PHATCH


(princ)
