

(defun c:LL () (load "phatch") (c:PHATCH))


;;; ------------------- GOLAYER -------------------------
	 ; name lineweith color linetype nonplot transparency
	(defun fx:GOLAYER (laylist / layername layerwt layercolor layerlt nonplot transparency layerx CHANGEFLAG otype elist)
		 ; name lineweight color linetype nonplot
		(setq layername (nth 0 laylist) 
			layerwt (nth 1 laylist) 
			layercolor (nth 2 laylist) 
			layerlt (nth 3 laylist)
			layerlt (fx:LTNAME layerlt)
			nonplot (if _SMARTNPLT ; then we figure it out from layer name
						(if (vl-string-search #FX1148 layername) 0 1) ; if nplt
						 ; otherwise, use the value passed to us
						(if (nth 4 laylist) 0 1)
					) ; if
			transparency (nth 5 laylist)
		) ; setq
		(if (not layercolor) 
			(setq layercolor 7)
		) ; if
		(if (not layerwt) (setq layerwt -3) (setq layerwt (fix (* layerwt 100))))
		(if (not layerlt) (setq layerlt "Continuous"))
		 ; okay, setup done, let's see if we can switch to this layer, make it as necessary
		(if (if (not (tblsearch "LAYER" layername))
				(progn 
					 ; can't make it unless the linetype exists
					(if (not (fx:LOADLINETYPE layerlt nil))
						 ; fine, keep it continuous then
						(setq layerlt "Continuous")
					) ; if

					(setq elist (list 
						(cons 0 "LAYER") 
						(cons 100 "AcDbSymbolTableRecord") 
						(cons 100 "AcDbLayerTableRecord") 
						(cons 2 layername) 
						(cons 6 layerlt)
						(cons 62 (if (> layercolor 255) 0 layercolor))
						(cons 70 0) 
						(cons 290 nonplot)
						(cons 370 layerwt)
					)) ; list setq
					(if (> layercolor 255) ; truecolor
						(setq elist (append elist (list (cons 420 layercolor))))
					) ; if

					(if (not (entmake elist))
						(fx:alert (strcat #FX0052 " " layername "."))
						 ; otherwise, cool to switch to
						(progn
							 ; if transparency, we need to set that via command line
							(if transparency 
								(command "_.-LAYER" "_TR" transparency layername "")
							) ; if
							 t
						) ; progn
					) ; if
				) ; progn
				 ; it exists, but we need to make sure it's unlocked, unfrozen, and turned on
				(progn 
					(setq layerx (entget (tblobjname "LAYER" layername)))
					(if (cdr (assoc 62 layerx)) ; if color assigned
						(if (minusp (cdr (assoc 62 layerx))) ; if layer is turned off
							(setq layerx (subst (cons 62 (abs (cdr (assoc 62 layerx)))) (assoc 62 layerx) layerx) 
								CHANGEFLAG t
							) ; setq
						) ; if layer off
					) ; if layer has color data
					(if (> (cdr (assoc 70 layerx)) 0) ; layer is frozen and/or locked
						(setq layerx (subst (cons 70 0) (assoc 70 layerx) layerx) 
							CHANGEFLAG t
						) ; setq
					) ; if
					(if CHANGEFLAG 
						(if (not (entmod layerx)) 
							(fx:alert #FX0053)
							 ; otherwise, go ahead
							 t
						) ; if
						 ; otherwise, it's on, thawed, unlocked
						 t
					) ; if layer locked/frozen/off
				) ; progn
			) ; if layer exists
			(setvar "CLAYER" layername)
		) ; if able to switch to layer
	) ; GOLAYER
;;; -----------------------------------------------------

;;; ------------------ fx:MAKE_CIRCLE -------------------
	(defun fx:MAKE_CIRCLE (px dx / entity1)
		(setq entity1 (list (cons 0 "CIRCLE") 
									(cons 100 "AcDbEntity")
									(cons 100 "AcDbCircle") 
									(append (list 10) px) 
									(cons 40 (/ dx 2.0)) ; radius
									(cons 67 0) ; create in MS
						) ; list
			entity1 (entmake entity1)
		) ; setq
	) ; fx:MAKE_CIRCLE
;;; -----------------------------------------------------

;;; ------------- REGIONTOPOLY --------------------------
	(defun fx:REGIONTOPOLY (eregion / lastent tempss)
		 ; given a region ename,
		 ; explode him and pedit join to a poly
		(setq lastent (entlast)
			tempss (ssadd)
		) ; setq
		(command "_.EXPLODE" eregion)
		(while (setq lastent (entnext lastent))
			(ssadd lastent tempss)
		) ; while
		(command "_.PEDIT" "_M" tempss "" "_Y" "_J" "0" "") ; multiple, Yes convert, Join
		(setq tempss nil)

		(entlast) ; our poly! (i hope)
	) ; REGIONTOPOLY
;;; -----------------------------------------------------



(defun c:PHATCH (/ *error* oldlay p2 exitflag esel t1 t2 DELETEENTITIES 
							r
							HATCHENT BOUNDENT BRUSHENT)
				 ; esel -
				 ; HATCHENT -
				 ; BOUNDENT -
				 ; BRUSHENT -
	(setq *error* AXIS_ERR)

	 ; --- consider, Place Hatch ---@@

	(setq oldlay (getvar "CLAYER"))
	(setvar "DELOBJ" 0) ; we need the original objects

	 ; select a hatch
	 	 ; ---- consider, looping until they select a hatch
	(if ; hatch selected...
		(and
			 ; select a hatch
			(setq esel (entsel #FX0143)) ; "\nSelect hatch: "
			(setq HATCHENT (entget (car esel)))
			 ; confirm it's hatch!
			(= (cdr (assoc 0 HATCHENT)) "HATCH")
		) ; and
		 ; continue to get boundary
		(if (setq BOUNDENT (fx:HATCHOWNER HATCHENT))
			 ; turn on the boundary layer
			(fx:GOLAYER (list (cdr (assoc 8 BOUNDENT))))

			 ; otherwise, no boundary!
			(progn
				(fx:ALERT #FX0129) ; "Can not locate bounding polyline."
				(exit)
			); progn
		) ; if

		 ; otherwise, exit
		(progn
			(fx:ALERT #FX0144) ; "Not a hatch."
			(exit)
		) ; progn
	) ; if

		 ; where to store brushes? default? snap to last used? ---------@@
	 ; make my brush
	(if (fx:MAKE_CIRCLE (trans (cadr esel) 1 0) (/ (getvar "VIEWSIZE") 10.0))
		(setq BRUSHENT (entget (entlast))
; @@ -- hatch the brush?
			DELETEENTITIES (list (entlast))
		) ; setq
		
		 ; otherwise
		(exit)
	) ; if
	 	 ; determine initial size -----------------@@

	(setq exitflag nil)
	(while 
			(and (not exitflag)
				(setq p2 (grread t 12 0)) ; t = Track, 12 = no Console Break and Cursor setting, 0 = crosshair only
			) ; and

;------------
;(print p2)
;------------

		 ; process the input
		(cond
			(	(= (car p2) 5) ; tracking
				 ; update brush position
				(setq p2 (cadr p2) ; just the UCS point itself
					p2 (trans p2 1 0) ; now WCS
					BRUSHENT (subst (append (list 10) p2) (assoc 10 BRUSHENT) BRUSHENT)
					BRUSHENT (entmod BRUSHENT)
				) ; setq
			) ; tracking
			
			(	(= (car p2) 3) ; left click
				 ; do my magic!

				 ; convert boundary and brush to regions
				(command "_.REGION" (cdr (assoc -1 BOUNDENT)) "")
				(setq t1 (entlast)) ; @@ succeed?
				
				(command "_.REGION" (cdr (assoc -1 BRUSHENT)) "")
				(setq t2 (entlast))

				 ; union them
				(command "_.UNION" t1 t2 "") ; deletes both t1 and t2, makes a new union
				(setq t2 (entlast)) ; union'ed region

				 ; validate that union -- area of the union, to area of source poly

				 ; back to a polyline
				(if (fx:REGIONTOPOLY t2)
					(setq t2 (entget (entlast))) ; union'ed as a poly
				) ; if

				(entdel (cdr (assoc -1 t2))) ; delete that poly

				 ; update boundary
				(setq BOUNDENT (reverse (cdr (member (assoc 90 BOUNDENT) (reverse BOUNDENT)))))

				(setq t2 (member (assoc 90 t2) t2))

				(setq BOUNDENT (append BOUNDENT t2))

				(entmod BOUNDENT)
				(command "_.REGEN") ; find a better way @@
			) ; left click
			
			(	(= (car p2) 2) ; keyboard
				(setq p2 (cadr p2)) ; just the ascii code
				(cond
					 ; W/S - Bigger/Smaller @@ keyboard customized?
					(	(member p2 (list (ascii "W") (ascii "w") (ascii "S") (ascii "s")))
						 ; make brush bigger/smaller
						 ; when it's a poly, helper function, move all vertices in or out @@
						 
						 (setq r (cdr (assoc 40 BRUSHENT)) ; radius of brush
						 	r (if (member p2 (list (ascii "W") (ascii "w")))
						 			(* r 1.1)
						 			 ; otherwise, smaller
						 			(* r 0.9)
						 		) ; if
						 	BRUSHENT (subst (cons 40 r) (assoc 40 BRUSHENT) BRUSHENT)
						 	BRUSHENT (entmod BRUSHENT)
						 ) ; setq
					) ; W/S

					 ; A/D - Rotate @@ 
				) ; cond

; @@ change brush
				 
				 ; @@ - U, to go back
				 
				 ; spacebar/enter --- @@
			) ; keyboard

			(	 t ; right click, click in ribbon, etc
				 ; exit
				(setq exitflag t)
			) ; otherwise
		) ; cond

	) ; while cursor move


	(foreach i DELETEENTITIES (entdel i))


	(fx:GOLAYER (list oldlay))


(princ)
) ; PHATCH


(princ)
